/*	Done by TheTutor -- 2/20/02

	First it's expected that you understand the following:

	1)  All the beginner C/C++ tutorials
	2)  Pointers and references
	4)  "console functions"
	3)  Classes

	If you feel inadequate in one of those areas, I highly recommended checking out 
	GameTutorials killer tutorials on those subjects :)

	What this tutorial is all about is really two things:  One is an introduction to an 
	OO (object oriented) style approach to game programming.  The other is the talking
	about the ABSOLUTE BASICS to AI programming.

	Now as mentioned in a prior game tutorial, you should always know what you are coding
	before you start -- So lets spec out the game:

	The game is Tic-Tac-Toe -- Yes very simple -- If you do not know how to play Tic-Tac-Toe well
	ahhhh.... Do a search on Google :)

	The game is one player only.  The human player will always be 'X' and the computer will
	always be 'O'.  When a game is finished, the program is over (I'm leaving the
	ability to "play again" as an exercise for you :)  -- The AI should be tough, but beatable.
	Lastly, the player will use the mouse for input.  Well, that's what we want, now lets go
	and make it :)

	***NOTE WIN2K and XP***
	*
	* For Win2K/XP users, you will HAVE to left-click on your console window (upper-left hand
	* corner) and select "Properties" -- Once there, under "Edit Options" turn OFF (uncheck)
	* BOTH "QuickEdit Mode" and "Insert Mode".  If you don't you won't get in game mouse clicks 
	* to register.  Also if you select "Defaults" instead of "Properties" you can permanently 
	* change this.
	*
	***********************

*/

#include "main.h"

// We keep main short and sweet
int main()
{
	GAMEDATA game;

	game.init();

	while(!game.getWinner())
		PlayGame(game);

	DispWinner(game);

// What in the heck does this ugly, nasty piece of code do?  Well it's really not 
// that bad.  What it is says is, "If we ARE NOT in a debug build, then add
// the function call "getchar()".  We do this, so in a RELEASE build, the window won't
// close instantly on us when the app is finished.
#ifndef _DEBUG
	getchar();
#endif

	return 0;
}


/////////////////////////////////////////// PlayGame() Implementation
/////////////////////////////////////////

// Plays the game
void PlayGame(GAMEDATA &gamedata)
{
	// If it's the AI turn to move, do so
	if(gamedata.getTurn() == AI_TURN)
	{
		AIMove(gamedata);
		gamedata.nextTurn();
	}
	else
		gamedata.getInput(); // Otherwise wait for the player to move
	
	gamedata.drawScreen(); // Draw the screen
	gamedata.calcWinner(); // See if anybody has won
}


/////////////////////////////////////////// DispWinner() Implementation
/////////////////////////////////////////

// Display a message so the player knows if they won/lost or tied
void DispWinner(const GAMEDATA &gamedata)
{
	switch(gamedata.getWinner())
	{
		case HUMAN_WINNER:

			cout << "You won, good job!" << endl;
				break;

		case AI_WINNER:

			cout << "You have been defeated!" << endl;
					break;

		case TIE:

			cout << "Tie!" << endl;
				break;
	}

}


// Summation...

// When doing AI, be sure to know how you want it to act -- It can be very difficult to 
// modify AI half way through a development cycle if all of a sudden you decide you 
// want it to behave in an entirely new way.
//
// Also avoid if/switch statements if possible -- Of course your game WILL NEED if/switch
// statements, so don't get ridiculous with this, just know that this is ONE area where
// you can potentially gain a little speed.  There are a ton of other optimization tricks
// and we'll cover them all eventually.

// Challenges	...

// 1)  Make it so the game doesn't just quit after ONE game
// 2)  Make it so the AI NEVER loses
// 3)  Make it so you can either play the computer or two player (same computer)


/*----------------------------*\
|  TheTutor                    |
|  thetutor@gametutorials.com  |
|   2001-2002 GameTutorials   |
\*----------------------------*/


